'use strict';

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _map = require('lodash/collection/map');

var _map2 = _interopRequireDefault(_map);

var _debounce = require('lodash/function/debounce');

var _debounce2 = _interopRequireDefault(_debounce);

var _includes = require('lodash/collection/includes');

var _includes2 = _interopRequireDefault(_includes);

var _range = require('lodash/utility/range');

var _range2 = _interopRequireDefault(_range);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _reactCssModules = require('react-css-modules');

var _reactCssModules2 = _interopRequireDefault(_reactCssModules);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { return obj && typeof Symbol !== "undefined" && obj.constructor === Symbol ? "symbol" : typeof obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/* eslint-disable react/no-set-state, react/no-did-mount-set-state */

var Carousel = (function (_Component) {
    _inherits(Carousel, _Component);

    function Carousel(props) {
        _classCallCheck(this, Carousel);

        var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(Carousel).call(this, props));

        _this.getIndexToScrollTo = function (_ref3) {
            var totalItems = _ref3.totalItems;
            var firstVisibleIndex = _ref3.firstVisibleIndex;
            var direction = _ref3.direction;
            var visibleItemsCount = _ref3.visibleItemsCount;
            var scrollStepDistance = _ref3.scrollStepDistance;

            var index = undefined,
                itemsBehindVisible = undefined,
                itemsBeyondVisible = undefined;

            itemsBeyondVisible = totalItems - firstVisibleIndex - visibleItemsCount;
            itemsBehindVisible = firstVisibleIndex;

            if (direction === 'next') {
                index = firstVisibleIndex + (itemsBeyondVisible > scrollStepDistance ? scrollStepDistance : itemsBeyondVisible);
            } else if (direction === 'previous') {
                index = firstVisibleIndex - (itemsBehindVisible > scrollStepDistance ? scrollStepDistance : itemsBehindVisible);
            }

            return index;
        };

        _this.isNextButtonVisible = function (firstVisibleIndex, totalItems, visibleItemsCount) {
            if (!(typeof firstVisibleIndex === 'number')) {
                throw new TypeError('Value of argument "firstVisibleIndex" violates contract, expected number got ' + (firstVisibleIndex === null ? 'null' : (typeof firstVisibleIndex === 'undefined' ? 'undefined' : _typeof(firstVisibleIndex)) === 'object' && firstVisibleIndex.constructor ? firstVisibleIndex.constructor.name || '[Unknown Object]' : typeof firstVisibleIndex === 'undefined' ? 'undefined' : _typeof(firstVisibleIndex)));
            }

            if (!(typeof totalItems === 'number')) {
                throw new TypeError('Value of argument "totalItems" violates contract, expected number got ' + (totalItems === null ? 'null' : (typeof totalItems === 'undefined' ? 'undefined' : _typeof(totalItems)) === 'object' && totalItems.constructor ? totalItems.constructor.name || '[Unknown Object]' : typeof totalItems === 'undefined' ? 'undefined' : _typeof(totalItems)));
            }

            if (!(typeof visibleItemsCount === 'number')) {
                throw new TypeError('Value of argument "visibleItemsCount" violates contract, expected number got ' + (visibleItemsCount === null ? 'null' : (typeof visibleItemsCount === 'undefined' ? 'undefined' : _typeof(visibleItemsCount)) === 'object' && visibleItemsCount.constructor ? visibleItemsCount.constructor.name || '[Unknown Object]' : typeof visibleItemsCount === 'undefined' ? 'undefined' : _typeof(visibleItemsCount)));
            }

            return firstVisibleIndex < totalItems - visibleItemsCount;
        };

        _this.getVisibleItemsCount = function (_ref4) {
            var firstVisibleIndex = _ref4.firstVisibleIndex;
            var maxWidth = _ref4.maxWidth;
            var totalItems = _ref4.totalItems;
            var itemWidth = _ref4.itemWidth;
            var controlWidth = _ref4.controlWidth;
            var itemMargin = _ref4.itemMargin;

            var availableWidth = undefined,
                calculateVisibleItemsCount = undefined,
                nextButtonVisible = undefined,
                prevButtonVisible = undefined,
                visibleItemsCount = undefined;

            /**
             * Get the number of visible items which can be shown at a time.
             *
             * @param {number} fullWidth Total available width in which items are to be shown
             * @param {number} elementWidth Width of each individual item to be inserted
             * @param {number} elementMargin Margin between two items
             * @returns {number}
             */
            // Keeping this function inside because
            // a) it's only need to be used internally in this function
            // b) All names I could come up for it can confuse user for this.getVisibleItemsCount
            calculateVisibleItemsCount = function (fullWidth, elementWidth, elementMargin) {
                return Math.floor(fullWidth / (elementWidth + elementMargin));
            };

            availableWidth = maxWidth;
            prevButtonVisible = _this.isPrevButtonVisible(firstVisibleIndex);

            if (prevButtonVisible) {
                availableWidth -= controlWidth + itemMargin;
            }

            visibleItemsCount = calculateVisibleItemsCount(availableWidth, itemWidth, itemMargin);
            nextButtonVisible = _this.isNextButtonVisible(firstVisibleIndex, totalItems, visibleItemsCount);

            if (nextButtonVisible) {
                availableWidth -= controlWidth + itemMargin;
                visibleItemsCount = calculateVisibleItemsCount(availableWidth, itemWidth, itemMargin);
            }

            return visibleItemsCount;
        };

        _this.handleScrollToDirection = function (direction, visibleItemsCount) {
            if (!(typeof direction === 'string')) {
                throw new TypeError('Value of argument "direction" violates contract, expected string got ' + (direction === null ? 'null' : (typeof direction === 'undefined' ? 'undefined' : _typeof(direction)) === 'object' && direction.constructor ? direction.constructor.name || '[Unknown Object]' : typeof direction === 'undefined' ? 'undefined' : _typeof(direction)));
            }

            if (!(typeof visibleItemsCount === 'number')) {
                throw new TypeError('Value of argument "visibleItemsCount" violates contract, expected number got ' + (visibleItemsCount === null ? 'null' : (typeof visibleItemsCount === 'undefined' ? 'undefined' : _typeof(visibleItemsCount)) === 'object' && visibleItemsCount.constructor ? visibleItemsCount.constructor.name || '[Unknown Object]' : typeof visibleItemsCount === 'undefined' ? 'undefined' : _typeof(visibleItemsCount)));
            }

            return function () {
                var index = undefined;

                index = _this.getIndexToScrollTo({
                    direction: direction,
                    totalItems: _this.props.items.length,
                    firstVisibleIndex: _this.props.firstVisibleIndex,
                    visibleItemsCount: visibleItemsCount,
                    scrollStepDistance: _this.props.scrollStepDistance
                });

                _this.props.onItemsScroll(index);
            };
        };

        _this.handleActivateItem = function (item) {
            _this.props.onItemActivate(item.key);
        };

        _this.getItemJsx = function (visibleItemsCount) {
            if (!(typeof visibleItemsCount === 'number')) {
                throw new TypeError('Value of argument "visibleItemsCount" violates contract, expected number got ' + (visibleItemsCount === null ? 'null' : (typeof visibleItemsCount === 'undefined' ? 'undefined' : _typeof(visibleItemsCount)) === 'object' && visibleItemsCount.constructor ? visibleItemsCount.constructor.name || '[Unknown Object]' : typeof visibleItemsCount === 'undefined' ? 'undefined' : _typeof(visibleItemsCount)));
            }

            /**
             * Creates JSX for one item
             *
             * @param {JSX} item Valid JSX for the item's content
             * @param {number} index Index of item in the items array
             * @param {number} visibleItemsCount Total number of visible items
             *
             * @returns {JSX}
             */
            return function (item, index) {
                var isVisible = undefined,
                    self = undefined,
                    visibleItemIndeces = undefined;

                self = _this;
                visibleItemIndeces = (0, _range2.default)(_this.props.firstVisibleIndex, visibleItemsCount + _this.props.firstVisibleIndex);

                isVisible = (0, _includes2.default)(visibleItemIndeces, index);

                /*
                 * Here we could return only those items which need be visible, but I am returning all.
                 * Since React does optimal DOM operations, rendering all items at once and then updating their
                 * style is much less expensive then rendering a set of new list-items everytime.
                 */
                return _react2.default.createElement(
                    'li',
                    {
                        key: item.key,
                        onClick: function onClick() {
                            self.handleActivateItem(item);
                        },
                        style: {
                            width: _this.props.itemWidth,
                            marginRight: _this.props.itemMargin,
                            display: isVisible ? 'list-item' : 'none'
                        },
                        styleName: 'cell' + (_this.props.activeItemId === item.key ? '-active' : '')
                    },
                    item
                );
            };
        };

        _this.state = { maxWidth: null };
        _this.resizeEventListener = (0, _debounce2.default)(function () {
            _this.setState({ maxWidth: _reactDom2.default.findDOMNode(_this.refs.wrapper).offsetWidth });
        }, 100);
        return _this;
    }

    _createClass(Carousel, [{
        key: 'componentDidMount',
        value: function componentDidMount() {
            this.setState({ maxWidth: _reactDom2.default.findDOMNode(this.refs.wrapper).offsetWidth });
            window.addEventListener('resize', this.resizeEventListener);
        }
    }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
            window.removeEventListener('resize', this.resizeEventListener);
        }

        /**
         * Get the index component should (safely) scroll to
         *
         * @param {Object} options
         * @property {number} options.totalItems Total number of items being displayed
         * @property {number} options.currentVisibleIndex Index of item in front
         * @property {string} options.direction next|previous Direction in which to scroll
         * @property {number} options.visibleItemsCount Number of items displayed at one time in component
         * @property {number} options.stepDistance Number of items to scroll in one step
         *
         * @returns {number} Index of item to which to scroll
         */

        /**
         * Tells if the next button shall be visible or not.
         */

    }, {
        key: 'isPrevButtonVisible',

        /**
         * Tells if the previous control button shall be visible or not.
         */
        value: function isPrevButtonVisible(firstVisibleIndex) {
            if (!(typeof firstVisibleIndex === 'number')) {
                throw new TypeError('Value of argument "firstVisibleIndex" violates contract, expected number got ' + (firstVisibleIndex === null ? 'null' : (typeof firstVisibleIndex === 'undefined' ? 'undefined' : _typeof(firstVisibleIndex)) === 'object' && firstVisibleIndex.constructor ? firstVisibleIndex.constructor.name || '[Unknown Object]' : typeof firstVisibleIndex === 'undefined' ? 'undefined' : _typeof(firstVisibleIndex)));
            }

            return firstVisibleIndex > 0;
        }

        /**
         * Get number of items that can be shown at a point in time.
         *
         * @param {Object} options Arguments in an object because they are too many
         * @property {number} firstVisibleIndex Index to which the carousel is scrolled to i.e first visible index
         * @property {number} maxWidth Maximum width available to the carousel
         * @property {number} totalItems Total number of items to be shown
         * @property {number} itemWidth Width of each item
         * @property {number} controlWidth Width of each control button
         * @property {number} itemMargin Margin between items
         * @returns {number}
         */

        /**
         * Helper function to avoid typing so many variables twice for two control buttons since most of the
         * variables are already in scope
         *
         * @param {string} direction direction in which to scroll
         * @param {number} visibleItemsCount Total number of visible items
         * @returns {undefined}
         */

        /**
         * Creates functoin that creates JSX for one item
         *
         * @param {number} visibleItemsCount Total number of visible items
         *
         * @returns {Function}
         */

    }, {
        key: 'render',
        value: function render() {
            // declaring so many variables instead of directly using props to stay consistent with the coding
            // style adopted for other components
            var controlWidth = undefined,
                firstVisibleIndex = undefined,
                itemMargin = undefined,
                itemWidth = undefined,
                items = undefined,
                maxWidth = undefined,
                nextButtonVisible = undefined,
                prevButtonVisible = undefined,
                totalItems = undefined,
                visibleItemsCount = undefined;

            maxWidth = this.state.maxWidth;
            items = this.props.items;
            controlWidth = this.props.controlWidth;
            firstVisibleIndex = this.props.firstVisibleIndex;
            itemWidth = this.props.itemWidth;
            itemMargin = this.props.itemMargin;
            totalItems = items.length;
            prevButtonVisible = this.isPrevButtonVisible(firstVisibleIndex);
            visibleItemsCount = this.getVisibleItemsCount({
                firstVisibleIndex: firstVisibleIndex,
                maxWidth: maxWidth,
                totalItems: totalItems,
                itemWidth: itemWidth,
                controlWidth: controlWidth,
                itemMargin: itemMargin
            });
            nextButtonVisible = this.isNextButtonVisible(firstVisibleIndex, totalItems, visibleItemsCount);

            return _react2.default.createElement(
                'div',
                { ref: 'wrapper', styleName: 'wrapper' },
                _react2.default.createElement(
                    'ul',
                    { styleName: 'carousel' },
                    _react2.default.createElement(
                        'li',
                        { onClick: this.handleScrollToDirection('previous', visibleItemsCount),
                            style: {
                                width: controlWidth,
                                marginRight: itemMargin,
                                display: prevButtonVisible ? 'list-item' : 'none'
                            },
                            styleName: 'control-cell-previous'
                        },
                        _react2.default.createElement('span', { styleName: 'control-icon-previous' })
                    ),
                    (0, _map2.default)(items, this.getItemJsx(visibleItemsCount)),
                    _react2.default.createElement(
                        'li',
                        { onClick: this.handleScrollToDirection('next', visibleItemsCount),
                            style: {
                                width: controlWidth,
                                display: nextButtonVisible ? 'list-item' : 'none'
                            },
                            styleName: 'control-cell-next'
                        },
                        _react2.default.createElement('span', { styleName: 'control-icon-next' })
                    )
                )
            );
        }
    }]);

    return Carousel;
})(_react.Component);

Carousel.propTypes = {
    activeItemId: _react.PropTypes.string,
    controlWidth: _react.PropTypes.number,
    firstVisibleIndex: _react.PropTypes.number,
    itemMargin: _react.PropTypes.number,
    itemWidth: _react.PropTypes.number,
    items: _react.PropTypes.arrayOf(_react.PropTypes.object).isRequired,
    onItemActivate: _react.PropTypes.func,
    onItemsScroll: _react.PropTypes.func,
    scrollStepDistance: _react.PropTypes.number
};
Carousel.defaultProps = {
    controlWidth: 30,
    firstVisibleIndex: 0,
    itemMargin: 1,
    itemWidth: 50,
    scrollStepDistance: 3
};

var styles = undefined;

styles = {};

exports.default = (0, _reactCssModules2.default)(Carousel, styles);
//# sourceMappingURL=index.js.map
